// trieda pre Frustum Culling
class FrustumCulling {
public:
 // funkcia pre vypocet Frustum
 void FrustumUpdate();

 // test, ci je bod vo Frustum x, y, z - 3D suradnice bodu
 bool PointInFrustum(GLfloat x,GLfloat y,GLfloat z);
 // test, ci je gula vo Frustum x, y, z - stred gule, radius - polomer
 bool SphereInFrustum(GLfloat x,GLfloat y,GLfloat z,GLfloat radius);
 // test, ci je kocka vo Frustum x, y, z - stred kocky, size - 1/2 velkosti
 bool CubeInFrustum(GLfloat x,GLfloat y,GLfloat z,GLfloat size);
 GLuint CubeInFrustum2(GLfloat x,GLfloat y,GLfloat z,GLfloat size);

 void CullTriangles(GLfloat *vertex,GLfloat *vertex1,
                    GLfloat *normal,GLfloat *normal1,
                    GLuint all_tris_num,GLuint *cull_tris_num);
private:
 // ulozenie A, B, C, D hodnot kazdej rezovej roviny Frustum
 GLfloat m_Frustum[6][4];

 GLuint i,j; // pomocne premenne
 GLuint a,b; // pomocne premenne
};

/*
  tento kod vznikol po uprave zverejneneho kodu autora:

  Ben Humphrey (DigiBen)
  Game Programmer
  DigiBen@GameTutorials.com
  Co-Web Host of www.GameTutorials.com
  date: 11/26/01
*/

